﻿/*Copyright 2024 Wojciech Krzysztof Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using VideoLibrary;

namespace AviMaker
{
    internal class Program
    {
        private static List<string> GetFileNames()
        {
            DirectoryInfo di = new DirectoryInfo(".\\");
            List<string> list = new List<string>();

            foreach(FileInfo fi in di.EnumerateFiles())
            {
                if (fi.Name.Contains(".jpg"))
                {
                    list.Add(fi.Name);
                }
            }
            return list;
        }
        static void Main(string[] args)
        {
            if(args.Count() != 1)
            {
                Console.WriteLine("AviMaker.exe name.avi");
                Console.ReadLine();
                return;
            }

            List<string> list = GetFileNames();
            int nr; int pos = 0;

            Console.WriteLine("Found {0} jpg's.", list.Count);
            nr = VideoManager.StartVideoCreation(args[0]);
            foreach(string name in list)
            {
                Bitmap bmp = new Bitmap(name);

                VideoManager.AddFrame(nr, bmp);
                Console.WriteLine(" {0}", pos);
                pos++;
            }
            VideoManager.FinishVideo(nr);
            Console.WriteLine("Finished.");
            Console.ReadLine();
        }
    }
}
