﻿/*Copyright 2015 Unknown Developer

Code Found by Wojciech Christopher Peter Fiałkiewicz in second half of 2015 somewhere in the internet.
 */

using System;
using System.Collections;
using System.Drawing;

namespace AviFile
{
    public class AviManager
	{
		private int aviFile = 0;
		private ArrayList streams = new ArrayList();

	    public AviManager(String fileName, bool open){
			Avi.AVIFileInit();
			int result;

			if(open){ //open existing file
				
				result = Avi.AVIFileOpen(
					ref aviFile, fileName,
					Avi.OF_READWRITE, 0);

			}else{ //create empty file
				
				result = Avi.AVIFileOpen(
					ref aviFile, fileName, 
					Avi.OF_WRITE | Avi.OF_CREATE, 0);
			
			}

			if(result != 0) {
				throw new Exception("Exception in AVIFileOpen: "+result.ToString());
			}
		}

        public VideoStream AddVideoStream(bool isCompressed, double frameRate, Bitmap firstFrame){
			VideoStream stream = new VideoStream(aviFile, isCompressed, frameRate, firstFrame);
			streams.Add(stream);
			return stream;
		}

        /// <summary>Release all ressources</summary>
        
        public void Close()
        {
			foreach(AviStream stream in streams){
				stream.Close();
			}
			
			Avi.AVIFileRelease(aviFile);
			Avi.AVIFileExit();
		}
    }
}
