﻿/*Copyright 2015 Unknown Developer

Code Found by Wojciech Christopher Peter Fiałkiewicz in second half of 2015 somewhere in the internet.
 */

using System.Collections.Generic;
using System.Drawing;
using System.Linq;

namespace VideoLibrary
{
    public class VideoManager
    {
        private static List<VideoData> m_Videos;

        static VideoManager()
        {
            m_Videos = new List<VideoData>();
        }

        public static int StartVideoCreation(string fileName)
        {
            VideoData vd= new VideoData();

            vd.FileName = fileName;
            vd.CurrentFrame = 0;
            
            m_Videos.Add(vd);
            
            return m_Videos.Count() - 1;
        }

        public static bool AddFrame(int videoNr, Bitmap bmp)
        {
            VideoData vd = m_Videos[videoNr];

            if(vd.CurrentFrame == 0)
            {
                vd.AviManager = new AviFile.AviManager(vd.FileName, false);

                vd.VideoStream = vd.AviManager.AddVideoStream(true, 60.0, bmp);
            }
            else
            {
                vd.VideoStream.AddFrame(bmp);
            }

            vd.CurrentFrame++;
            return true;
        }

        public static bool FinishVideo(int videoNr)
        {
            VideoData vd = m_Videos[videoNr];

            vd.AviManager.Close();
            return true;
        }

        public static void FreeMem(int videoNr)
        {
            m_Videos[videoNr] = null;
        }
    }
}
